﻿USING System
USING System.Collections.Generic
USING System.Linq
USING System.Text
USING vars

BEGIN NAMESPACE Vars
    
    //
    // The VAR keyword has been added to the language because in many situations
    // the result of an expression will be directly assigned to a local, and the expression
    // will already describe the type of the variable
    // VAR is a synonym for LOCAL IMPLIED 
    
    
    FUNCTION Start() AS VOID
        // IS / ASTYPE
        CheckType()
        // VAR declaration
        VarImplied()
        // DYNAMIC type
        DynamicType()
        //
        Console.WriteLine( "End of Sample - Press Return to Continue" )
        Console.ReadLine()
        
    FUNCTION CheckType() AS VOID
        LOCAL myPerson AS UserID
        LOCAL myDev AS Developer
        LOCAL myCust AS Customer
        //
        myPerson = UserID{} 
        //
        myDev = Developer{}{ FirstName = "Fabrice", LastName = "Foray" }
        // Hey by the way, look at the way to Init Field ! :)
        myCust = Customer{}{ FirstName = "Clint", LastName = "Eastwood" }
        //
        WriteInfo( myPerson )
        WriteInfo( myDev )
        WriteInfo( myCust )
        //
        RETURN
        
    FUNCTION WriteInfo( obj AS OBJECT ) AS VOID
        Console.WriteLine("---===---") 
        Console.WriteLine("CheckType : ") 
        Console.WriteLine("---===---") 
        //
        IF( obj IS UserID )
            ? "This is a UserID"
        ENDIF
        IF( obj IS Developer )
            ? "This is a Developer"
        ENDIF
        IF( obj IS Customer )
            ? "This is a Customer"
        ENDIF
        IF( obj IS IIdentification )
            ? "It has Identification Interface"
        ENDIF
        //
        LOCAL temp AS IIdentification
        temp = obj ASTYPE IIdentification
        IF ( temp != NULL )
            ? "The FullName is " + temp.GetFullName()
        ENDIF
        ? "The FullName is " + temp?.GetFullName()
        //? "The FullName is " + temp?.GetFullName()
        //
        ? "Press Return to Continue" 
        Console.ReadLine()
        RETURN
        
    PROCEDURE VarImplied() AS VOID
        // VAR / IMPLIED / LOCAL IMPLIED are resolved at Compile Time
        //
        Console.WriteLine("---===---") 
        Console.WriteLine("Var & Implied : ") 
        Console.WriteLine("---===---") 
        // The STRING type is infered from the return type of BuildList
        FOR EACH VAR cName IN BuildList()
            //
            Console.WriteLine( "Welcome to " + cName )
            //
        ENDFOR
        //
        // In the next line the compiler "knows" that today is a DateTime
        VAR today = System.DateTime.Now
        ? today
        
        // In the next line the compiler "knows" that text is a String
        VAR text  = Convert.ToString(123)
        ? text
        
        // and here, guess what
        VAR myVar = 123.45
        ? myVar.GetType().ToString()
        ? "Press Return to Continue" 
        Console.ReadLine()
        
        
    FUNCTION BuildList() AS List<STRING>
        LOCAL myList AS List<STRING>
        //
        myList = List<STRING>{}
        //
        myList.AddRange( <STRING>{ "Chris", "Fabrice", "Nikos", "Robert" } )
        //
        RETURN myList
        
        
    FUNCTION DynamicType() AS VOID
        LOCAL myVar = 123.45 AS DYNAMIC
        ? myVar.GetType().ToString()
        //
        LOCAL myDev = Developer{ }{ FirstName = "Nikos", LastName = "Kokkalis" } AS DYNAMIC
        ? myDev.GetFullName()
        // But warning, Calls are resolved at RunTime
        myDev?.UnknownMethod()
        ? "Press Return to Continue" 
        Console.ReadLine()
        RETURN
        
END NAMESPACE