﻿// FirstSample.prg
// Created by    : fabri
// Creation Date : 4/10/2019 11:01:24 PM
// Created for   : 
// WorkStation   : FABPORTABLE


USING System
USING System.Collections.Generic
USING System.Text
USING System.Net.Http
USING System.Threading.Tasks

FUNCTION FirstSample AS VOID
	Console.WriteLine( "Before the Async Method" )
	TestASync.DoTheJob()
	Console.WriteLine("After the Async call!")
	
	Console.WriteLine("Press any key to continue...but wait a bit please :) ....")
	Console.ReadKey()
	RETURN
	
CLASS TestASync


	ASYNC STATIC METHOD DoTheJob() AS VOID
		VAR totalLength = AWAIT TestASync.AccessTheWebAsync()
		Console.WriteLine("Size read : " + totalLength.ToString() )
		
		// Three things to note in the signature:
		//  - The method has an async modifier. 
		//  - The return type is Task or Task<T>. (See "Return Types" section.)
		//    Here, it is Task<int> because the return statement returns an integer.
	//  - The method name ends in "Async."
	ASYNC STATIC METHOD AccessTheWebAsync() AS Task<INT64>
		LOCAL len AS LONG
		// Declare client.
		VAR client = HttpClient{}
		
		// GetStringAsync returns a Task<string>. That means that when you await the
		// task you'll get a string (urlContents).
		LOCAL getStringTask = client.GetStringAsync("http://www.swfox.net") AS Task<STRING> 
		
		// You can do work here that doesn't rely on the string from GetStringAsync.
		DoIndependentWork()
		
		// The await operator suspends AccessTheWebAsync.
		//  - AccessTheWebAsync can't continue until getStringTask is complete.
		//  - Meanwhile, control returns to the caller of AccessTheWebAsync.
		//  - Control resumes here when getStringTask is complete. 
		//  - The await operator then retrieves the string result from getStringTask.
		TRY
			VAR urlContents = AWAIT getStringTask
			len = urlContents.Length
		CATCH e AS Exception
			? "Exception : " + e:Message
		END TRY
		// The return statement specifies an integer result.
		// Any methods that are awaiting AccessTheWebAsync retrieve the length value.
		RETURN len
		
	STATIC METHOD DoIndependentWork() AS VOID
		Console.WriteLine( "Welcome to the main work...")
		
END CLASS
