﻿// SecondSample.prg
// Created by    : fabri
// Creation Date : 4/10/2019 11:02:39 PM
// Created for   : 
// WorkStation   : FABPORTABLE


USING System
USING System.Collections.Generic
USING System.Text
USING System.Net.Http
USING System.Threading.Tasks

	//
	// This example shows that you can call an async task and wait for it to finish
	// The result of the async task (in this case the size of the file that has been downloaded)
	// will be come available when the task has finished
	// The calling code (The Start()) function will not have to wait until the async task has
	// finished. That is why the line "2....." will be printed before the results from TestClass.DoTest()
	// The sample also shows an event and displays the thread id's. You can see that the DownloadFileTaskAsync() method
	// starts multiple threads to download the web document in multiple pieces.

	FUNCTION SecondSample() AS VOID
		? "1. calling long process"
		TestClass.DoTest()
		? "2. this should be printed while processing"
		Console.ReadKey()

 

	CLASS TestClass        
		STATIC PROTECT oLock AS OBJECT                // To make sure we synchronize the writing to the screen
		
		STATIC CONSTRUCTOR
			 oLock = OBJECT{}

 
		ASYNC STATIC METHOD DoTest() AS VOID
			LOCAL Size AS INT64
			Size = AWAIT LoooongProcess()
			? "3. returned from long process"
			? Size, " Bytes downloaded"

 

		ASYNC STATIC METHOD LoooongProcess() AS Task<INT64>
			LOCAL WebClient = System.Net.WebClient{} AS System.Net.WebClient
			LOCAL FileName = System.IO.Path.GetTempPath()+"temp.txt" AS STRING
			webClient:DownloadProgressChanged += OnDownloadProgress
			webClient:Credentials = System.Net.CredentialCache.DefaultNetworkCredentials

			// Wait for the ASYNC Task to End
			AWAIT webClient:DownloadFileTaskAsync("http://www.swfox.net/whoscoming.aspx", FileName)
			VAR dirInfo      = System.IO.DirectoryInfo{System.IO.Path.GetTempPath()}
			VAR Files        = dirInfo:GetFiles("temp.txt")
			IF Files:Length > 0
				System.IO.File.Delete(FileName)
				RETURN Files[1]:Length
			ENDIF

			RETURN 0

 

	 STATIC METHOD OnDownloadProgress (sender AS OBJECT, e AS System.Net.DownloadProgressChangedEventArgs) AS VOID
			// Critical section, to be sure will not comes here twice (or more) while the printing is not over
			LOCAL percent AS Int64
			//
			percent = (100*e:BytesReceived) / e:TotalBytesToReceive
			BEGIN LOCK oLock
				? String.Format("{0,3} % Size: {1,8:N0} Thread {2}", percent  , e:BytesReceived, ;
							   System.Threading.Thread.CurrentThread:ManagedThreadId)
			END LOCK
			RETURN

	END CLASS 