﻿USING System
USING System.Collections.Generic
USING System.ComponentModel
USING System.Data
USING System.Drawing
USING System.Linq
USING System.Text
USING System.Threading.Tasks
USING System.Windows.Forms
USING System.io
USING XSharp.RT
BEGIN NAMESPACE SimpleDbf
	PUBLIC PARTIAL CLASS MainWindow ;
	INHERIT System.Windows.Forms.Form
		PUBLIC CONSTRUCTOR()
			InitializeComponent()
			
			//
			RETURN
		PRIVATE METHOD quitToolStripMenuItem_Click(sender AS OBJECT, e AS System.EventArgs) AS VOID
			IF ( MessageBox.Show( "Close Application ?", "SWFox 2019", MessageBoxButtons.YesNo, MessageBoxIcon.Question ) == DialogResult.Yes )
				SELF:Close()
			ENDIF
		PRIVATE METHOD openToolStripMenuItem_Click(sender AS OBJECT, e AS System.EventArgs) AS VOID STRICT
			LOCAL ofd AS OpenFileDialog
			//
			ofd := OpenFileDialog{}
			ofd:CheckFileExists := TRUE
			ofd:DefaultExt := "Dbf"
			ofd:Filter = "Dbf files (*.dbf)|*.dbf|All files (*.*)|*.*"
			IF ( ofd:ShowDialog() == DialogResult.OK )
				SELF:OpenDBF( ofd:FileName )
			ENDIF

		PRIVATE METHOD OpenDBF(fileName AS STRING ) AS VOID
			LOCAL oDT AS DataTable
			LOCAL row AS DataRow
			//
			oDT := DataTable{ Path.GetFileName(fileName )}
			//
			DbUseArea(TRUE, "DBFNTX",fileName)
			// Create the Columns
			FOR VAR i := 1 UPTO FCount()
				oDT:Columns:Add( FIELDNAME((DWORD)i), typeof(STRING) )
			NEXT
			// Now load with data
			DbGotop()
			DO WHILE ! EOF()
				// Create a new row
				row := oDT:NewRow()
				// Put data into the columns in the row
				FOR VAR i := 1 UPTO FCount()
					row[ FIELDNAME((DWORD)i) ] := AsString(FieldGet(i))
				NEXT
				// Add the row to the table
				oDT:Rows:Add(row)
				// Move to next record
				DbSkip()
			ENDDO
			DbCloseArea()
			// Now attach the DataTable to the DataGridView
			//
			SELF:dataGridView1:DataSource := oDT
			RETURN
			
	END CLASS
END NAMESPACE
