﻿USING System
USING System.Collections.Generic
USING System.ComponentModel
USING System.Data
USING System.Drawing
USING System.Linq
USING System.Text
USING System.Threading.Tasks
USING System.Windows.Forms
USING System.io
USING MySql.Data.MySqlClient
BEGIN NAMESPACE SimpleSQL2
	PUBLIC PARTIAL CLASS MainWindow ;
	INHERIT System.Windows.Forms.Form
		PRIVATE currentFile AS STRING
		PRIVATE ip AS STRING
		PRIVATE connect AS MySql.Data.MySqlClient.MySqlConnection
		PUBLIC CONSTRUCTOR()
			InitializeComponent()
			//
			LOCAL file AS StreamReader
			file := StreamReader{ "config.txt" }
			ip := file:ReadLine()
			file:Close()
			//
			RETURN
		PRIVATE METHOD buttonAdd_Click(sender AS OBJECT, e AS System.EventArgs) AS VOID
			LOCAL oDlg AS UserWindow
			//
			oDlg := UserWindow{}
			oDlg:ShowDialog()
			IF ( oDlg:DialogResult == DialogResult.OK )
				SELF:AddContact( oDlg:User )
			ENDIF
		PRIVATE METHOD quitToolStripMenuItem_Click(sender AS OBJECT, e AS System.EventArgs) AS VOID
			IF ( MessageBox.Show( "Close Application ?", "SWFox 2019", MessageBoxButtons.YesNo, MessageBoxIcon.Question ) == DialogResult.Yes )
				SELF:Close()
			ENDIF
			
		PRIVATE METHOD openToolStripMenuItem_Click(sender AS OBJECT, e AS System.EventArgs) AS VOID
			LOCAL sb AS MySqlConnectionStringBuilder
			LOCAL cmd AS MySqlCommand
			LOCAL reader AS MySqlDataReader
			//
			sb := MySqlConnectionStringBuilder{}
			sb:Server := SELF:ip
			sb:Database := "xsharp"
			sb:UserID := "xsharp"
			sb:Password := "xsharp"
			//
			connect := MySqlConnection{}
			connect:ConnectionString := sb:ConnectionString
			connect:Open()
			//
			cmd := MySqlCommand{}
			cmd:CommandText := "SELECT * From Contacts"
			cmd:Connection := connect
			//
			reader := cmd:ExecuteReader()
			// Clear the Items List
			SELF:listContacts:Items:Clear()
			//
			LOCAL line AS STRING
			LOCAL User AS UserInfo
			WHILE ( reader:Read() )
				line := reader["Id"]:ToString() +";" + reader["Firstname"]:ToString() + ";" + reader["Lastname"]:ToString() + ";" + reader["EMail"]:ToString()
				User := UserInfo{ line }
				SELF:FillContact( User )
			ENDDO
			//
			reader:Close()
			connect:Close()
			SELF:buttonAdd:Enabled := TRUE
			SELF:buttonModify:Enabled := TRUE
			SELF:buttonDelete:Enabled := TRUE
			
			
			
		PRIVATE METHOD listContacts_SelectedIndexChanged(sender AS OBJECT, e AS System.EventArgs) AS VOID
			//
			SELF:buttonModify:Enabled := TRUE
			SELF:buttonDelete:Enabled := TRUE
		PRIVATE METHOD AddContact(User AS UserInfo) AS VOID
			LOCAL cmd AS MySqlCommand
			LOCAL reader AS MySqlDataReader
			//
			connect:Open()
			//
			cmd := MySqlCommand{}
			cmd:CommandText := "INSERT INTO Contacts (`Firstname`, `LastName`, `Email`) VALUES ('"+ User:FirstName+"','" + User:LastName +"','"+ User:EMail +"') "
			cmd:Connection := connect
			cmd:ExecuteNonQuery()
			//
			cmd := MySqlCommand{}
			cmd:CommandText := "SELECT LAST_INSERT_ID() From Contacts"
			cmd:Connection := connect
			//
			reader := cmd:ExecuteReader()
			reader:Read()
			User:Id := reader:GetInt32(0)
			//
			SELF:FillContact( User )
			//
			connect:Close()
		PRIVATE METHOD FillContact(User AS UserInfo) AS VOID
			LOCAL lvi AS ListViewItem
			//
			lvi := ListViewItem{ User:Id:ToString() }
			lvi:SubItems:Add( User:FirstName )
			lvi:SubItems:Add( User:LastName )
			lvi:SubItems:Add( User:EMail )
			//
			SELF:listContacts:Items:Add( lvi )
		PRIVATE METHOD buttonModify_Click(sender AS OBJECT, e AS System.EventArgs) AS VOID
			LOCAL lvi AS ListViewItem
			LOCAL oDlg AS UserWindow
			//
			IF ( SELF:listContacts:SelectedItems:Count > 0 )
				lvi := SELF:listContacts:SelectedItems[0]
				oDlg := UserWindow{}
				oDlg:User:Id := Int32.Parse(lvi:Text)
				oDlg:User:FirstName := lvi:SubItems[1]:Text
				oDlg:User:LastName := lvi:SubItems[2]:Text
				oDlg:User:EMail := lvi:SubItems[3]:Text
				oDlg:ValidateUser()
				//
				oDlg:ShowDialog()
				IF ( oDlg:DialogResult == DialogResult.OK )
					lvi:SubItems[1]:Text := oDlg:User:FirstName
					lvi:SubItems[2]:Text := oDlg:User:LastName 
					lvi:SubItems[3]:Text := oDlg:User:EMail
					//
					LOCAL cmd AS MySqlCommand
					//
					connect:Open()
					//
					cmd := MySqlCommand{}
					cmd:CommandText := "UPDATE Contacts SET `Firstname`='" + oDlg:User:FirstName +"', `LastName`='" + oDlg:User:LastName + ;
					"' , `Email`='" + oDlg:User:EMail + "' WHERE `id`=" + oDlg:User:Id:ToString()
					cmd:Connection := connect
					cmd:ExecuteNonQuery()
					//
					connect:Close()
					//
				ENDIF
			ENDIF
		PRIVATE METHOD buttonDelete_Click(sender AS OBJECT, e AS System.EventArgs) AS VOID
			LOCAL lvi AS ListViewItem
			IF ( SELF:listContacts:SelectedItems:Count > 0 )
				lvi := SELF:listContacts:SelectedItems[0]
				//
				LOCAL cmd AS MySqlCommand
				//
				connect:Open()
				//
				cmd := MySqlCommand{}
				cmd:CommandText := "DELETE FROM `contacts` WHERE `id`=" + lvi.Text
				cmd:Connection := connect
				cmd:ExecuteNonQuery()
				//
				connect:Close()
				//
				lvi:Remove()
			ENDIF
			
	END CLASS
END NAMESPACE
