﻿// UserInfo.prg
// Created by    : fabri
// Creation Date : 3/24/2017 5:21:17 PM
// Created for   : 
// WorkStation   : FABPORTABLE


USING System
USING System.Collections.Generic
USING System.Text

BEGIN NAMESPACE SimpleSQL2

	/// <summary>
    /// The UserInfo class.
    /// </summary>
	CLASS UserInfo
        PROPERTY FirstName AS STRING AUTO
        PROPERTY LastName AS STRING AUTO
        PROPERTY EMail AS STRING AUTO
        PROPERTY Id AS INT AUTO

        PROPERTY IsValid AS LOGIC GET SELF:_IsValid()

    CONSTRUCTOR( )
        RETURN

    CONSTRUCTOR( csvLine AS STRING )
        LOCAL items AS STRING[]
        //
        items := csvLine:Split( ';' )
        IF ( items:Length == 4 )
            SELF:Id := int32.Parse( items[1] )
            SELF:FirstName := items[2]
            SELF:LastName := items[3]
            SELF:EMail := items[4]
        ENDIF
        RETURN

    PRIVATE METHOD _IsValid() AS LOGIC
        IF ( String.IsNullOrEmpty( SELF:FirstName ) .AND. String.IsNullOrEmpty( SELF:LastName ) .AND.String.IsNullOrEmpty( SELF:EMail ) )
            RETURN FALSE
        ENDIF
        RETURN TRUE

    PROPERTY AsCSV AS STRING
        GET
            RETURN SELF:Id:ToString() + ";" + SELF:FirstName + ";" + SELF:LastName + ";" + SELF:EMail
        END GET
    END PROPERTY

	END CLASS
END NAMESPACE // SimpleSQL2
