// Data.prg
USING System
USING System.Collections.Generic
USING System.Text
USING System.IO
USING System.Collections.ObjectModel
USING System.ComponentModel

BEGIN NAMESPACE SimpleWpf

	PUBLIC CLASS Photo
	
		PRIVATE _source AS STRING
		
		PUBLIC PROPERTY Source AS STRING
			GET
				RETURN _Source
			END GET
		END PROPERTY
		
		CONSTRUCTOR( path AS STRING )
			_source := path
			RETURN
			
		PUBLIC METHOD ToString() AS STRING
			RETURN Source
			
			END CLASS
			
	PUBLIC CLASS PhotoList INHERIT ObservableCollection<Photo>
	
		PRIVATE _directory AS DirectoryInfo
		
		CONSTRUCTOR()
			RETURN
			
		CONSTRUCTOR( folder AS STRING )
			SELF:Path := folder
			RETURN
			
		CONSTRUCTOR( directory AS DirectoryInfo )
			_directory := directory
			FillData()
			RETURN
			
		PUBLIC PROPERTY Path AS STRING
			SET
				_directory := DirectoryInfo{ VALUE }
				FillData()
			END SET
			
			GET
				RETURN _directory:FullName
			END GET
		END PROPERTY
		
		PUBLIC PROPERTY Directory AS DirectoryInfo
			SET
				_directory := VALUE 
				FillData()
			END SET
			
			GET
				RETURN _directory
			END GET
		END PROPERTY
		
		PRIVATE METHOD FillData() AS VOID
			//
			FOREACH file AS FileInfo IN _directory:GetFiles("*.jpg")
				SELF:Add( Photo{ file:FullName } )
			NEXT
			
			
	END CLASS
	
END NAMESPACE // SimpleWpf
